/* -*- Javascript -*- */

/* global variables */

var file = null;
var export_filename = 'export_alias.csv';
var nb_items = 0;

var names = new Array ('Alias', 'Directory', 'Configuration file', 'Description', 'Function');
var vars = new Array ('alias', 'dirname', 'configfile', 'description', 'func');

function add_row (pos, line, isAppend) {
  if (typeof isAppend === 'undefined') isAppend = 1;

  if (line == null)
    line = new Array ();

  var table = document.getElementById ('config');
  if (!table) {
    return {stat: 1, msg: 'can\'t find old table'};
  }

  if (pos < 0) {
    pos = 0;
  } else {
    var ref = document.getElementById ('var_' + pos);
    if (ref) {
      for (var i = 0; i < table.rows.length; i++) {
        if (table.rows[i].id == 'var_' + pos) {
          pos = i + ((isAppend) ? 1 : 0);
          break;
        }
      }
    } else {
      pos = table.rows.length;
    }
  }

  /* create row */
  var row = table.insertRow (pos);
  row.id = 'var_' + nb_items;
  for (var j in vars) {
    var cell = document.createElement ('td');
    cell.setAttribute ('oncontextmenu', 'javascript: show_menu(event, ' + nb_items + ');');
    row.appendChild (cell);

    var input = document.createElement ('input');
    input.type = 'text';
    input.value = (typeof line[j] !== 'undefined') ? line[j] : '';

    /* special */
    switch (j) {
    case '0':
      input.title = 'if empty, description field will be used to add a header line';
      input.size = 8;
      break;
    case '2':
      input.title = 'if empty, the line will define an action button';
      break;
    case '3':
      input.title = 'if empty, this line will not be displayed';
      break;
    case '4':
      input.title = 'Optionnal';
      break;
    }
    cell.className = (j == '0') ? 'fit' : 'expand';
    input.id = vars[j] + '_' + nb_items;
    cell.appendChild (input);
  }

  nb_items++;

  return {stat: 0, msg: (isAppend) ? 'appending new item' : 'inserting new item'};
}

/* delete row */

function delete_row (pos) {

  var stat = 2;
  var msg = 'can\'t find reference';

  var ref = document.getElementById ('var_' + pos);
  if (ref)  {
    var nb = 0;
    for (var i = 0; i < ref.parentNode.rows.length; i++)
      if (ref.parentNode.rows[i].id.match (/var_/))
        nb++;
    if (nb > 1) {
      var father = ref.parentNode;
      father.removeChild (ref);
      stat = 0;
      msg = 'removing current item';
    } else {
      stat = 1;
      msg = 'removing current item';
    }
  }

  return {msg: msg, stat: stat};
}

/* import procedure */

function import_proc (data) {

  /* remove previous table */
  var table = document.getElementById ('config');
  if (!table) {
    update_status ('can\'t find previous table');
    return;
  }
  var father = table.parentNode;
  father.removeChild (table);

  /* save data file*/
  file = data;
  nb_items = 0;

  /* create new table */
  var table = document.createElement ('table');
  table.className = 'table';
  table.id = 'config';
  father.appendChild (table);

  /* create header row */
  var row_header = table.insertRow (0);
  for (var i in names) {
    var cell_header = document.createElement ('th');
    row_header.appendChild (cell_header);
    cell_header.innerHTML = names[i];
    cell_header.className = (i == '0') ? 'fit' : 'expand';
  }

  /* for each line */
  var tab = data.split ('\n');
  for (var i in tab) {

    var line = tab[i].replace (/#.*/, '').split (';');
    if (line.length <= 1)
      continue;
    for (var j = 5; j < line.length; j++) {
      line[4] += ';' + line[j];
      delete line[j];
    }

    /* create row */
    add_row (nb_items, line);
  }

  /* remove previous list */
  var list_dt = document.getElementById ('list');
  if (!list_dt) {
    update_status ('can\'t find previous form list');
    return;
  }
  father = list_dt.parentNode;
  father.removeChild (list_dt);

  /* create new table */
  list_dl = document.createElement ('div');
  list_dl.id = 'list';
  var buffer = '<dl>\n';

  /* create list */
  for (var i = 0; i< nb_items; i++) {
    var ref_alias = document.getElementById ('alias_' + i);
    if (!ref_alias) continue;
    var ref_desc = document.getElementById ('description_' + i);
    if (!ref_desc) continue;
    var ref_configfile = document.getElementById ('configfile_' + i);
    if (!ref_configfile) continue;
    var ref_func = document.getElementById ('func_' + i);

    /* avoid to list item if there's no description */
    if (ref_desc.value.length == 0)
      continue;

    /* add a subheader if there's no alias */
    if (ref_alias.value.length == 0) {

      /* special case to customize page title */
      if ((ref_func) && (ref_func.value == ':title:')) {
        document.title = ref_desc.value;
        var h1 = document.getElementsByTagName ('h1')[0];
        if (h1)
          h1.innerHTML = ref_desc.value;

      } else

        buffer += '</dl>\n<h2>' + ref_desc.value + '</h2>\n<dl>\n';

      continue;
    }

    /* add a action button if there's no configuration file */
    if (ref_configfile.value.length == 0) {

      /* special case for redirecion */
      if (!((ref_func) && (ref_func.value == ':goto:'))) {
        buffer += '<dt onclick="javascript: apply_file (\'' + ref_alias.value + '\');">' + ref_desc.value + '</dt>\n';

        continue;
      }
    }

    /* add a service*/
    buffer += '<dt onclick="javascript: goto_url (\'' + ref_alias.value + '\');" oncontextmenu="javascript: goto_url (\'' + ref_alias.value + '\', ' + i + '); return false;">' + ref_desc.value + '</dt>\n';
  }
  buffer += '</dl>\n';
  list_dl.innerHTML = buffer;

  /* add new list into html page */
  father.appendChild (list_dl);

  /* table is updated */
  update_status ('import done', 0);
}

/* export raw database */

function export_proc () {

  /* build CSV data */
  var data = '# -*- CSV -*-';

  /* remove previous table */
  var table = document.getElementById ('config');
  if (!table) {
    return;
  }

  for (var i = 0; i < table.rows.length; i++) {
    if (table.rows[i].id == '') continue;
    var line = '';
    for (var j in vars) {
      var id = table.rows[i].id.replace (/var_/, vars[j] + '_');
      var ref = document.getElementById (id);
      line += ((j > 0) ? ';' : '') + ((ref) ? ref.value : '');
    }

    data += '\n' + line;
  }

  return data;
}

/* menu function */

function is_last_item () {

  /* count remaining items */
  var nb = 0;
  for (var i = 0; i < nb_items; i++)
    if (document.getElementById ('var_' + i))
      nb++;

  return (nb > 1);
}

menu = new Array (menuCallback ('Append new entry', null, function (id) { return add_row (id, null, true); }),
                  menuCallback ('Insert new entry', null, function (id) { return add_row (id, null, false); }),
                  menuCallback ('Remove current entry', is_last_item, function (id) { return delete_row (id); }));
